//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main()
{
  //    7.7
  cout << ToRus("   7.7:\n");
  fill_n(ostream_iterator<float>(cout, " "), //  
         10,                                 // 
         7.7);                               //  
  cout << endl;

  list<string> coll;

  //    ""
  fill_n(back_inserter(coll),       //  
         9,                         // 
         ToRus(""));                  //  
  PRINT_ELEMENTS(coll,":\n");

  //     ""
  fill(coll.begin(), coll.end(),    // 
       ToRus(""));                    //  
  PRINT_ELEMENTS(coll,"  :\n");

  //   ,  ,  ""
  fill_n(coll.begin(),              //  
         coll.size()-2,             // 
         ToRus(""));                     //  
  PRINT_ELEMENTS(coll,"   :\n");

  //        ""
  list<string>::iterator pos1, pos2;
  pos1 = coll.begin();
  pos2 = coll.end();
  fill (++pos1, --pos2,              // 
        ToRus(""));                     //  
  PRINT_ELEMENTS(coll,"   :\n");


  getch();
  return 0;
}

//---------------------------------------------------------------------------